package org.granite.tide.cdi;

import javax.inject.Inject;
import javax.inject.Named;
import javax.interceptor.AroundInvoke;
import javax.interceptor.Interceptor;
import javax.interceptor.InvocationContext;

import org.granite.messaging.amf.io.util.externalizer.DefaultExternalizer;
import org.granite.messaging.amf.io.util.externalizer.annotation.ExternalizedBean;


@TideBean
@ExternalizedBean( type = DefaultExternalizer.class )
@Interceptor
public class TideBeanInterceptor
{

    @Inject
    CDIServiceContext tideContext;

    @AroundInvoke
    public Object doAround( InvocationContext context ) throws Exception
    {
        Object result = context.proceed();

        String componentName = null;
        if( context.getTarget().getClass().isAnnotationPresent( Named.class ) )
        {
            componentName = context.getTarget().getClass().getAnnotation( Named.class ).value();
        }

        tideContext.addResultEval( new ScopedContextResult( componentName, null, context.getTarget() ) );

        return result;
    }
}
